/******************************************************************************
 *
 * Name:	sdiobus.c
 * Project:	Export driver for SDIO API
 * Version:	$Revision: 1.1 $
 * Date:	$Date: 2007/01/18 09:30:19 $
 * Purpose:	Export driver for SDIO API
 *
 ******************************************************************************/

/******************************************************************************
 *
 *	(C)Copyright 2005 Marvell
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYSKONNECT
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 *	This Module contains Proprietary Information of SysKonnect
 *	and should be treated as Confidential.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of SysKonnect.
 *	Such users have the right to use, modify, and incorporate this code
 *	into products for purposes authorized by the license agreement
 *	provided they include this notice and the associated copyright notice
 *	with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 *
 ******************************************************************************/

/******************************************************************************
 *
 * History:
 *
 *	$Log: apimain.c,v $
 *	Revision 1.1  2007/01/18 09:30:19  pweber
 *	Put under CVS control
 *	
 *	
 ******************************************************************************/
#ifndef _lint
static const char SysKonnectFileId[] = "@(#)" __FILE__ " (C) Marvell ";
#endif /* !_lint */

#include "drvvers.h"

#define SDIO_BUS_DRIVER

#include "h/sdioapi.h"

#ifdef DBG
ULONG apiDebugLevel = DBG_DEFAULT;
#ifdef WINNT
LARGE_INTEGER t1Time, t1LastTime, t1CurTime;
LARGE_INTEGER t2Time, t2LastTime, t2CurTime;
LARGE_INTEGER t3Time, t3LastTime, t3CurTime;
LARGE_INTEGER t4Time, t4LastTime, t4CurTime;
LARGE_INTEGER t5Time, t5LastTime, t5CurTime;
LARGE_INTEGER t6Time, t6LastTime, t6CurTime;
#endif // #ifdef WINNT
#endif // #ifdef DBG

#ifdef WINNT
NTSTATUS
DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);

#ifdef ALLOC_PRAGMA
#pragma alloc_text(INIT, DriverEntry)
#endif

// The DLL must have an entry point, but it is never called.
//
NTSTATUS
DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath)
{
    return STATUS_SUCCESS;
}

NTSTATUS
DllInitialize(IN PUNICODE_STRING RegistryPath)
{
    INITDEBUG();
    DBGPRINT(DBG_ALL, ("*** %s ***\n", SK_SIGNON_MSG));
    DBGPRINT(DBG_ALL, ("*** Built on %s %s ***\n", __DATE__, __TIME__));

#if DBG
    DBGPRINT(DBG_ALL, ("*** DEBUG version ***\n"));
#else
    DBGPRINT(DBG_ALL, ("*** FREE version ***\n"));
#endif

    return STATUS_SUCCESS;
}

NTSTATUS
DllUnload()
{
    DBGPRINT(DBG_LOAD, ("SDIOAPI: DllUnload\n"));
    return STATUS_SUCCESS;
}
#else // #ifdef WINNT
static int
sdioapi_init_module(void)
{
//      PSDIO_OBJECT pSdioObject;

    DBGPRINT(DBG_LOAD, (KERN_DEBUG "Module sdioapi init\n"));

    return 0;
}

static void
sdioapi_exit_module(void)
{
    DBGPRINT(DBG_LOAD, (KERN_DEBUG "Module sdioapi exit\n"));
}

module_init(sdioapi_init_module);
module_exit(sdioapi_exit_module);

#endif
