#ifndef	_SDIO_H_
#define	_SDIO_H_

#include "sdio_spec.h"
#include	"sdio_if.h"

/* CMD53 parameter*/
//mode
#define BLOCK_MODE	0x1
#define BYTE_MODE    0x0
//opcode
#define FIXED_ADDRESS 	0x0
#define INCREMENTAL_ADDRESS 0x1

#define	MMC_TYPE_HOST		1
#define	MMC_TYPE_CARD		2
#define	MMC_REG_TYPE_USER	3

#ifdef SDIO_BUS_DRIVER

#define	MVSD_DAT 			0
#define	MVSD_CMD			1
#define	MVSD_EVENT    			3

#define SD_BLOCK_SIZE	32

/***
//
//          Bit definition
//
#define DW_BIT_0        0x00000001
#define DW_BIT_1        0x00000002
#define DW_BIT_2        0x00000004
#define DW_BIT_3        0x00000008
#define DW_BIT_4        0x00000010
#define DW_BIT_5        0x00000020
#define DW_BIT_6        0x00000040
#define DW_BIT_7        0x00000080
#define DW_BIT_8        0x00000100
#define DW_BIT_9        0x00000200
#define DW_BIT_10       0x00000400
#define DW_BIT_11       0x00000800
#define DW_BIT_12       0x00001000
#define DW_BIT_13       0x00002000
#define DW_BIT_14       0x00004000
#define DW_BIT_15       0x00008000
#define DW_BIT_16       0x00010000
#define DW_BIT_17       0x00020000
#define DW_BIT_18       0x00040000
#define DW_BIT_19       0x00080000
#define DW_BIT_20       0x00100000
#define DW_BIT_21       0x00200000
#define DW_BIT_22       0x00400000
#define DW_BIT_23       0x00800000
#define DW_BIT_24       0x01000000
#define DW_BIT_25       0x02000000
#define DW_BIT_26       0x04000000
#define DW_BIT_27       0x08000000
#define DW_BIT_28       0x10000000
#define DW_BIT_29       0x20000000
#define DW_BIT_30       0x30000000
#define DW_BIT_31       0x80000000

#define W_BIT_0         0x0001
#define W_BIT_1         0x0002
#define W_BIT_2         0x0004
#define W_BIT_3         0x0008
#define W_BIT_4         0x0010
#define W_BIT_5         0x0020
#define W_BIT_6         0x0040
#define W_BIT_7         0x0080
#define W_BIT_8         0x0100
#define W_BIT_9         0x0200
#define W_BIT_10        0x0400
#define W_BIT_11        0x0800
#define W_BIT_12        0x1000
#define W_BIT_13        0x2000
#define W_BIT_14        0x4000
#define W_BIT_15        0x8000

****/

#define BIT_0         0x01
#define BIT_1         0x02
#define BIT_2         0x04
#define BIT_3         0x08
#define BIT_4         0x10
#define BIT_5         0x20
#define BIT_6         0x40
#define BIT_7         0x80

/* FBR (Function Basic Registers) */
#define FN_CSA_REG(x)             (0x100 * (x) + 0x00)
#define FN_CIS_POINTER_0_REG(x)   (0x100 * (x) + 0x09)
#define FN_CIS_POINTER_1_REG(x)   (0x100 * (x) + 0x0a)
#define FN_CIS_POINTER_2_REG(x)   (0x100 * (x) + 0x0b)
#define FN_CSA_DAT_REG(x)         (0x100 * (x) + 0x0f)
#define FN_BLOCK_SIZE_0_REG(x)    (0x100 * (x) + 0x10)
#define FN_BLOCK_SIZE_1_REG(x)    (0x100 * (x) + 0x11)

/* The following defines function 1 registers of SD25 */
/* Ref.: SD-25 SDIO Interface Specification Rev. 2.0.  */
/*       Marvell Semiconductor, Inc.                  */

/* Host Control Registers */

#define IO_PORT_0_REG								0x00
#define IO_PORT_1_REG								0x01
#define IO_PORT_2_REG								0x02
#define CONFIGURATION_REG						0x03
#define HOST_WO_CMD53_FINISH_HOST		(0x1U << 2)
#define HOST_POWER_UP								(0x1U << 1)
#define HOST_POWER_DOWN							(0x1U << 0)
#define HOST_INT_MASK_REG						0x04
#define UP_LD_HOST_INT_MASK					(0x1U << 0)
#define DN_LD_HOST_INT_MASK					(0x1U << 1)
#define HOST_INTSTATUS_REG					0x05
#define UP_LD_HOST_INT_STATUS				(0x1U)
#define DN_LD_HOST_INT_STATUS				(0x2U)
#define IO_ABORT_REG              	0x06
#define HOST_INT_RSR_REG						0x06
#define UP_LD_HOST_INT_RSR					(0x1U)
#define HOST_INT_STATUS_REG					0x07
#define UP_LD_CRC_ERR								(0x1U << 2)
#define UP_LD_RESTART              (0x1U << 1)
#define DN_LD_RESTART              (0x1U << 0)

/* Card Control Registers */
#define SQ_READ_BASE_ADDRESS_A0_REG  0x10
#define SQ_READ_BASE_ADDRESS_A1_REG  0x11
#define SQ_READ_BASE_ADDRESS_A2_REG  0x12
#define SQ_READ_BASE_ADDRESS_A3_REG  0x13
#define SQ_READ_BASE_ADDRESS_B0_REG  0x14
#define SQ_READ_BASE_ADDRESS_B1_REG  0x15
#define SQ_READ_BASE_ADDRESS_B2_REG  0x16
#define SQ_READ_BASE_ADDRESS_B3_REG  0x17
#define CARD_STATUS_REG              0x20
#define IO_READY                   (0x1U << 3)
#define CIS_CARD_RDY               (0x1U << 2)
#define UP_LD_CARD_RDY             (0x1U << 1)
#define DN_LD_CARD_RDY             (0x1U << 0)
#define HOST_INTERRUPT_MASK_REG      0x24
#define HOST_POWER_INT_MASK        (0x1U << 3)
#define ABORT_CARD_INT_MASK        (0x1U << 2)
#define UP_LD_CARD_INT_MASK        (0x1U << 1)
#define DN_LD_CARD_INT_MASK        (0x1U << 0)

// 2005-02-18 mmoser
#define UP_LD_CARD_INT             (0x1U << 0)
#define DN_LD_CARD_INT             (0x1U << 1)

#define CARD_INTERRUPT_STATUS_REG    0x28
#define POWER_UP_INT               (0x1U << 4)
#define POWER_DOWN_INT             (0x1U << 3)
#define CARD_INTERRUPT_RSR_REG       0x2c
#define POWER_UP_RSR               (0x1U << 4)
#define POWER_DOWN_RSR             (0x1U << 3)
#define DEBUG_0_REG                  0x30
#define SD_TESTBUS0                (0x1U)
#define DEBUG_1_REG                  0x31
#define SD_TESTBUS1                (0x1U)
#define DEBUG_2_REG                  0x32
#define SD_TESTBUS2                (0x1U)
#define DEBUG_3_REG                  0x33
#define SD_TESTBUS3                (0x1U)
#define CARD_OCR_0_REG               0x34
#define CARD_OCR_1_REG               0x35
#define CARD_OCR_3_REG               0x36
#define CARD_CONFIG_REG              0x38
#define CMD53_FINISH_GBUS          (0x1U << 1)
#define SD_NEG_EDGE                (0x1U << 0)

/* Special registers in function 0 of the SD25 card */
#define	SCRATCH_0_REG			0x80fe
#define	SCRATCH_1_REG			0x80ff

#define HOST_F1_RD_BASE_0		0x0010
#define HOST_F1_RD_BASE_1		0x0011
#define HOST_F1_CARD_RDY		0x0020

 /**/
#define FIRMWARE_READY			0xfedc
/* The number of times to try when polling for status bits */
#define MAX_POLL_TRIES	 		100
/*Firmware download parameter*/
#define FIRMWARE_DOWNLOAD_BLOCK_SIZE 32 //include the size header 4 bytes
#define MAX_FIRMWARE_POLL_TRIES 100
#define FIRMWARE_TRANSFER_NBLOCK 2
#endif // SDIO_BUS_DRIVER
#endif /*sdio.h */
