/******************************************************************************
 *
 * Name:	sktypes.h
 * Project:	Wireless LAN, SDIO Bus driver
 * Version:	$Revision: 1.1 $
 * Date:	$Date: 2007/01/18 09:26:19 $
 * Purpose:	Define data types for SDIO bus driver
 *
 ******************************************************************************/

/******************************************************************************
 *
 *	(C)Copyright 2004 Marvell.
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYSKONNECT
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 *	This Module contains Proprietary Information of SysKonnect
 *	and should be treated as Confidential.
 *
 *	The information in this file is provided for the exclusive use of
 *	the licensees of Marvell.
 *	Such users have the right to use, modify, and incorporate this code
 *	into products for purposes authorized by the license agreement
 *	provided they include this notice and the associated copyright notice
 *	with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 *
 ******************************************************************************/

/******************************************************************************
 *
 * History:
 *
 *	$Log: sktypes.h,v $
 *	Revision 1.1  2007/01/18 09:26:19  pweber
 *	Put under CVS control
 *	
 *	
 *
 ******************************************************************************/

#ifndef __INC_SKTYPES_H
#define __INC_SKTYPES_H

/* defines ********************************************************************/

/*
 * Data types with a specific size. 'I' = signed, 'U' = unsigned.
 */
#ifdef WINNT
typedef unsigned char u_char;
typedef unsigned short u_short;
typedef unsigned long u_long;
typedef unsigned int u_int;
typedef char *caddr_t;
#define SK_I8   CHAR
#define SK_U8		UCHAR
#define SK_I16	SHORT
#define SK_U16	USHORT
#define SK_I32	LONG
#define SK_U32	ULONG
#define SK_U64	long long

#else // #ifdef WINNT
#define SK_I8	s8
#define SK_U8	u8
#define SK_I16	s16
#define SK_U16	u16
#define SK_I32	s32
#define SK_U32	u32
#define SK_U64	u64
#endif

#define SK_UPTR	SK_U32          /* casting pointer <-> integral */

#define	SK_CONSTI64(x)	(x##L)
#define	SK_CONSTU64(x)	(x##UL)
/*
 * Boolean type.
 */
#define SK_BOOL		SK_U8
#define SK_FALSE	(SK_BOOL)0
#define SK_TRUE		(SK_BOOL)(!SK_FALSE)

#ifndef WINNT

#define VOID 		void
#define PVOID 	VOID*
#define ULONG		SK_U32
#define USHORT	SK_U16
#define UCHAR		SK_U8
#define PUCHAR	SK_U8*
#define BOOLEAN	SK_BOOL
#define IN
#define OUT

typedef struct _GUID
{
    SK_U32 Data1;
    SK_U16 Data2;
    SK_U16 Data3;
    SK_U8 Data4[8];
} GUID, *PGUID;

#define COMPARE_GUID(guid1,guid2) (\
((guid1).Data1==(guid2).Data1) && \
((guid1).Data2==(guid2).Data2) && \
((guid1).Data3==(guid2).Data3) && \
(memcmp((guid1).Data4,(guid2).Data4,8)==0))

#define SHOW_GUID(guid) {	\
int i; \
printk("\n{ 0x%8.08X, 0x%4.04X, 0x%4.04X,{",(guid).Data1,(guid).Data2,(guid).Data3);\
for (i=0;i < 8;i++){printk("0x%2.02X ",(guid).Data4[i]);} \
printk("}\n");}

#endif

#define DEFINE_EXTERN_GUID(name) \
	extern const GUID name

#define DEFINE_INIT_GUID(name, l, w1,w2,b1,b2,b3,b4,b5,b6,b7,b8) \
	const GUID name \
		= { l, w1, w2, { b1, b2, b3, b4, b5, b6, b7, b8 } }

/* typedefs *******************************************************************/

/* function prototypes ********************************************************/

#endif /* __INC_SKTYPES_H */
